lauriys
lauriys

Reputation: 4792

How to test an Internet connection with bash?

How can an internet connection be tested without pinging some website? I mean, what if there is a connection but the site is down? Is there a check for a connection with the world?

Upvotes: 149

Views: 329486

Answers (24)

Doron Behar
Doron Behar

Reputation: 2878

Similarly to @Jesse's answer, this option might be much faster than any solution using ping and perhaps slightly more efficient than @Jesse's answer.

find /sys/class/net/ -maxdepth 1 -mindepth 1 ! -name "*lo*" -exec sh -c 'cat "$0"/carrier 2>&1' {} \; | grep -q '1'

Explanation:

This command uses find with -exec to run command on all files not named *lo* in /sys/class/net/. These should be links to directories containing information about the available network interfaces on your machine.

The command being ran is an sh command that checks the contents of the file carrier in those directories. The value of $interface/carrier has 3 meanings - Quoting:

It seems there are three states:

  • ./carrier not readable (for instance when the interface is disabled in Network Manager).
  • ./carrier contain "1" (when the interface is activated and it is connected to a WiFi network)
  • ./carrier contain "0" (when the interface is activated and it is not connected to a WiFi network)

The first option is not taken care of in @Jesse's answer. The sh command striped out is:

# Note: $0 == $interface
cat "$0"/carrier 2>&1

cat is being used to check the contents of carrier and redirect all output to standard output even when it fails because the file is not readable. If grep -q finds "1" among those files it means there is at least 1 interface connected. The exit code of grep -q will be the final exit code.

Usage

For example, using this command's exit status, you can use it start a gnubiff in your ~/.xprofile only if you have an internet connection.

online() {
    find /sys/class/net/ -maxdepth 1 -mindepth 1 ! -name "*lo*" -exec sh -c 'cat "$0"/carrier 2>&1 > /dev/null | grep -q "1" && exit 0' {} \;
}
online && gnubiff --systemtray --noconfigure &

Reference

Upvotes: 5

Seamus
Seamus

Reputation: 230

Here's how I do it in my bash scripts:

while :
    do
        socat /dev/null TCP4:google.com:443,connect-timeout=2 && break
        sleep 60
    done

Put socat in an infinite loop. If the socat invocation is true ($? -eq 0), the break gets executed, and I continue the script. If not, I sleep for 60 secs & try again.

I've found this useful for dealing with short-term Internet outages. If you've got a server more reliable than google.com:443 - use that instead.

Upvotes: 0

user23107660
user23107660

Reputation:

With netcat check port 80:

$ nc -vz 203.0.113.96 80
nc: connect to 203.0.113.96 port 80 (tcp) failed: Connection refused

Upvotes: 0

Sebastien Willemijns
Sebastien Willemijns

Reputation: 15

This is a script who test internet connection: sometimes unique DNS server can give timeout for any reason so... let's use other servers by

ping=NOK ; debug= ; for (( ; ; )) do
value=9.9.9.9 ; if ping -q -w 2 -c 1 $value > /dev/null; then ping=OK ; debug=$value ; break ; fi
value=8.8.8.8 ; if ping -q -w 2 -c 1 $value > /dev/null; then ping=OK ; debug=$value ; break ; fi
value= ; break;
done
if [ "$ping" == "NOK" ]; then echo No internet !!! ; else echo Internet connection is $ping \(result given by $value DNS server\). ; fi
read $r

Upvotes: 0

Kajukenbo
Kajukenbo

Reputation: 285

In case it helps someone, I do it like this. It just "retries" until the network is "alive". You can echo output here just for POL. true or continue can act as a no-op. You must have some sort of command in the loop, even of only an echo or continue. Use any tools or commands you wish.

#!/bin/sh

site='www.unix.com'
until $(ping -q -c1 ${site} > /dev/null 2>&1)
do
    echo "${site} is unreachable. Retrying"
    # continue
done

echo "online"

You can modify the until clause to use almost any tool you want this way. I use ping because many commercial boxes do not have "netcat" or the like. Even if one does, it does not mean you have the access needed to run the command. Pinging the domain confirms I can actually resolve names on the Internet.

Everything is POSIX (except the tool that does the actual check, of course) so it does not require Bashisms and it is easy to modify to suit my needs.

Upvotes: 0

legel
legel

Reputation: 2673

This works on both MacOSX and Linux:

#!/bin/bash

ping -q -c1 google.com &>/dev/null && echo online || echo offline

Upvotes: 34

Vinicius Fortuna
Vinicius Fortuna

Reputation: 572

If you want to handle captive portals, you can do this oneliner:

if [[ $(curl -s -D - http://www.gstatic.com/generate_204 2>/dev/null | head -1 | cut -d' ' -f 2) == "204" ]]; then
  echo 'online'
else
  echo 'offline'
fi

Or if you want something more readable that can differentiate captive portals from lack of signal:

function is_online() {
  # Test signal
  local response
  response=$(curl --silent --dump-header - http://www.gstatic.com/generate_204 2> /dev/null)
  if (($? != 0)); then return 2; fi
  # Test captive portal
  local status=$(echo $response | head -1 | cut -d' ' -f 2)
  ((status == "204"))
}
is_online && echo online || echo offline

Upvotes: 0

Alberto Salvia Novella
Alberto Salvia Novella

Reputation: 1249

For the fastest result, ping a DNS server:

ping -c1 "8.8.8.8" &>"/dev/null"

if [[ "${?}" -ne 0 ]]; then
    echo "offline"
elif [[ "${#args[@]}" -eq 0 ]]; then
    echo "online"
fi

Available as a standalone command: linkStatus

Upvotes: 3

Chaminda Bandara
Chaminda Bandara

Reputation: 2170

Execute the following command to check whether a web site is up, and what status message the web server is showing:

curl -Is http://www.google.com | head -1 HTTP/1.1 200 OK

Status code ‘200 OK’ means that the request has succeeded and a website is reachable.

Upvotes: 7

Luchostein
Luchostein

Reputation: 2444

In Bash, using it's network wrapper through /dev/{udp,tcp}/host/port:

if : >/dev/tcp/8.8.8.8/53; then
  echo 'Internet available.'
else
  echo 'Offline.'
fi

(: is the Bash no-op, because you just want to test the connection, but not processing.)

Upvotes: 27

Ajedi32
Ajedi32

Reputation: 48438

If your goal is to actually check for Internet access, many of the existing answers to this question are flawed. A few things you should be aware of:

  1. It's possible for your computer to be connected to a network without that network having internet access
  2. It's possible for a server to be down without the entire internet being inaccessible
  3. It's possible for a captive portal to return an HTTP response for an arbitrary URL even if you don't have internet access

With that in mind, I believe the best strategy is to contact several sites over an HTTPS connection and return true if any of those sites responds.

For example:

connected_to_internet() {
  test_urls="\
  https://www.google.com/ \
  https://www.microsoft.com/ \
  https://www.cloudflare.com/ \
  "

  processes="0"
  pids=""

  for test_url in $test_urls; do
    curl --silent --head "$test_url" > /dev/null &
    pids="$pids $!"
    processes=$(($processes + 1))
  done

  while [ $processes -gt 0 ]; do
    for pid in $pids; do
      if ! ps | grep "^[[:blank:]]*$pid[[:blank:]]" > /dev/null; then
        # Process no longer running
        processes=$(($processes - 1))
        pids=$(echo "$pids" | sed --regexp-extended "s/(^| )$pid($| )/ /g")

        if wait $pid; then
          # Success! We have a connection to at least one public site, so the
          # internet is up. Ignore other exit statuses.
          kill -TERM $pids > /dev/null 2>&1 || true
          wait $pids
          return 0
        fi
      fi
    done
    # wait -n $pids # Better than sleep, but not supported on all systems
    sleep 0.1
  done

  return 1
}

Usage:

if connected_to_internet; then
  echo "Connected to internet"
else
  echo "No internet connection"
fi

Some notes about this approach:

  1. It is robust against all the false positives and negatives I outlined above
  2. The requests all happen in parallel to maximize speed
  3. It will return false if you technically have internet access but DNS is non-functional or your network settings are otherwise messed up, which I think is a reasonable thing to do in most cases

Upvotes: 2

Arjun G
Arjun G

Reputation: 2294

This bash script continuously check for Internet and make a beep sound when the Internet is available.

#!/bin/bash
play -n synth 0.3 sine 800 vol 0.75
while :
do
pingtime=$(ping -w 1 8.8.8.8 | grep ttl)
if [ "$pingtime" = "" ] 
then 
   pingtimetwo=$(ping -w 1 www.google.com | grep ttl) 
   if [ "$pingtimetwo" = "" ] 
   then 
       clear ; echo 'Offline'
   else
       clear ; echo 'Online' ; play -n synth 0.3 sine 800 vol 0.75
   fi 
else
    clear ; echo 'Online' ; play -n synth 0.3 sine 800 vol 0.75
fi
sleep 1
done

Upvotes: 4

Fuwan
Fuwan

Reputation: 131

The top answer misses the fact that you can have a perfectly stable connection to your default gateway but that does not automatically mean you can actually reach something on the internet. The OP asks how he/she can test a connection with the world. So I suggest to alter the top answer by changing the gateway IP to a known IP (x.y.z.w) that is outside your LAN.

So the answer would become:

ping -q -w 1 -c 1 x.y.z.w > /dev/null && echo ok || echo error

Also removing the unfavored backticks for command substitution[1].

If you just want to make sure you are connected to the world before executing some code you can also use:

if ping -q -w 1 -c 1 x.y.z.w > /dev/null; then
    # more code
fi

Upvotes: 9

Francisc0
Francisc0

Reputation: 1018

The top voted answer does not work for MacOS so for those on a mac, I've successfully tested this:

GATEWAY=`route -n get default | grep gateway`
if [ -z "$GATEWAY" ]
  then
    echo error
else
  ping -q -t 1 -c 1 `echo $GATEWAY | cut -d ':' -f 2` > /dev/null && echo ok || echo error
fi

tested on MacOS High Sierra 10.12.6

Upvotes: 6

WaiKit Kung
WaiKit Kung

Reputation: 1296

make sure your network allow TCP traffic in and out, then you could get back your public facing IP with the following command

curl ifconfig.co

Upvotes: 8

Alex Moore-Niemi
Alex Moore-Niemi

Reputation: 3382

shortest way: fping 4.2.2.1 => "4.2.2.1 is alive"

i prefer this as it's faster and less verbose output than ping, downside is you will have to install it.

you can use any public dns rather than a specific website.

fping -q google.com && echo "do something because you're connected!"

-q returns an exit code, so i'm just showing an example of running something you're online.

to install on mac: brew install fping; on ubuntu: sudo apt-get install fping

Upvotes: 3

user3439968
user3439968

Reputation: 3538

Without ping

#!/bin/bash

wget -q --spider http://google.com

if [ $? -eq 0 ]; then
    echo "Online"
else
    echo "Offline"
fi

-q : Silence mode

--spider : don't get, just check page availability

$? : shell return code

0 : shell "All OK" code

Without wget

#!/bin/bash

echo -e "GET http://google.com HTTP/1.0\n\n" | nc google.com 80 > /dev/null 2>&1

if [ $? -eq 0 ]; then
    echo "Online"
else
    echo "Offline"
fi

Upvotes: 183

dm76
dm76

Reputation: 4270

Checking Google's index page is another way to do it:

#!/bin/bash

WGET="/usr/bin/wget"

$WGET -q --tries=20 --timeout=10 http://www.google.com -O /tmp/google.idx &> /dev/null
if [ ! -s /tmp/google.idx ]
then
    echo "Not Connected..!"
else
    echo "Connected..!"
fi

Upvotes: 2

Jesse
Jesse

Reputation: 329

Super Thanks to user somedrew for their post here: https://bbs.archlinux.org/viewtopic.php?id=55485 on 2008-09-20 02:09:48

Looking in /sys/class/net should be one way

Here's my script to test for a network connection other than the loop back. I use the below in another script that I have for periodically testing if my website is accessible. If it's NOT accessible a popup window alerts me to a problem.

The script below prevents me from receiving popup messages every five minutes whenever my laptop is not connected to the network.

#!/usr/bin/bash

# Test for network conection
for interface in $(ls /sys/class/net/ | grep -v lo);
do
  if [[ $(cat /sys/class/net/$interface/carrier) = 1 ]]; then OnLine=1; fi
done
if ! [ $OnLine ]; then echo "Not Online" > /dev/stderr; exit; fi

Note for those new to bash: The final 'if' statement tests if NOT [!] online and exits if this is the case. See man bash and search for "Expressions may be combined" for more details.

P.S. I feel ping is not the best thing to use here because it aims to test a connection to a particular host NOT test if there is a connection to a network of any sort.

P.P.S. The Above works on Ubuntu 12.04 The /sys may not exist on some other distros. See below:

Modern Linux distributions include a /sys directory as a virtual filesystem (sysfs, comparable to /proc, which is a procfs), which stores and allows modification of the devices connected to the system, whereas many traditional UNIX and Unix-like operating systems use /sys as a symbolic link to the kernel source tree.[citation needed]

From Wikipedia https://en.wikipedia.org/wiki/Filesystem_Hierarchy_Standard

Upvotes: 32

tomoe
tomoe

Reputation: 3066

Pong doesn't mean web service on the server is running; it merely means that server is replying to ICMP echo. I would recommend using curl and check its return value.

Upvotes: 1

nikudesu
nikudesu

Reputation: 238

Ping was designed to do exactly what you're looking to do. However, if the site blocks ICMP echo, then you can always do the telnet to port 80 of some site, wget, or curl.

Upvotes: 2

mateusza
mateusza

Reputation: 5753

Ping your default gateway:

#!/bin/bash
ping -q -w 1 -c 1 `ip r | grep default | cut -d ' ' -f 3` > /dev/null && echo ok || echo error

Upvotes: 102

ephemient
ephemient

Reputation: 205014

If your local nameserver is down,

ping 4.2.2.1

is an easy-to-remember always-up IP (it's actually a nameserver, even).

Upvotes: 6

paxdiablo
paxdiablo

Reputation: 882686

I've written scripts before that simply use telnet to connect to port 80, then transmit the text:

HTTP/1.0 GET /index.html

followed by two CR/LF sequences.

Provided you get back some form of HTTP response, you can generally assume the site is functioning.

Upvotes: 7

Related Questions